#ifndef BRUSH_H_INCLUDED
#define BRUSH_H_INCLUDED

#include "Point.h"
#include "Color.h"

#define BRUSH_POINT             0
#define BRUSH_LINE              1
#define BRUSH_CIRCLE            2
#define BRUSH_SCATTERED_POINTS  3
#define BRUSH_SCATTERED_LINES   4
#define BRUSH_SCATTERED_CIRCLES 5
#define BRUSH_COUNT             6

////////////////////////////////////////////////////////////////////////
// Class Brush Declaration
//
// This is the base class for all brushes. Feel free to change the 
// declaration of the virutal member functions as (will be) needed.
////////////////////////////////////////////////////////////////////////

class Brush 
{
public:
	Brush() { }
	virtual ~Brush() { }

	// The implementation of your brush should realize these virtual functions:
	// BrushBegin() is called when the mouse button is pressed
	// BrushMove() is called when user drags the mouse
	// BrushEnd() is called when the button is released

	virtual void BrushBegin(int iSize, Color cColor, const Point& ptTarget) = 0;
	virtual void BrushMove(int iSize, Color cColor, const Point& ptTarget) = 0;
	virtual void BrushEnd(int iSize, Color cColor, const Point& ptTarget) = 0;
};

#endif // BRUSH_H_INCLUDED
