#include <windows.h>
#include <GL/gl.h>
#include <GL/glu.h>

#include "DotBrush.h"

////////////////////////////////////////////////////////////////////////
// Class DotBrush Implementation
// 
// It is a subclass of Brush. All your brush implementations will look 
// like this but with different GL primitive calls.
////////////////////////////////////////////////////////////////////////

void DotBrush::BrushBegin(int iSize, Color cColor, const Point& ptTarget)
{
	BrushMove(iSize, cColor, ptTarget);
}

void DotBrush::BrushMove(int iSize, Color cColor, const Point& ptTarget)
{
	glPointSize((float)iSize);
	glBegin(GL_POINTS);
		glColor4ub(cColor.r, cColor.g, cColor.b, cColor.a);
		glVertex3f((float)ptTarget.x, (float)ptTarget.y, 0.0f);
	glEnd();
}

void DotBrush::BrushEnd(int iSize, Color cColor, const Point& ptTarget)
{
}

