#include <FL/Fl.h>

#include "ImpressionistView.h"
#include "ImpressionistModel.h"

int main(int argc, char **argv) 
{
#ifdef WIN32
	DWORD dwBtnFaceColor = GetSysColor(COLOR_BTNFACE);

	// Get consistent background color
	Fl::background(GetRValue(dwBtnFaceColor), 
		GetGValue(dwBtnFaceColor),
		GetBValue(dwBtnFaceColor));
#endif // WIN32

	// Create the model (document)
	ImpressionistModel *pmModel = new ImpressionistModel();
	// Create the view
	ImpressionistView *pvView = new ImpressionistView(pmModel);

	Fl::visual(FL_DOUBLE | FL_RGB);

	// Show the FLTK windows
	pvView->Show();
	// ... and starts the message loop
	Fl::run();

	// If we're here, all windows are closed and we're done
	delete pvView;
	delete pmModel;

	return 0;
}
