#ifndef IMPRESSIONISTVIEW_H_INCLUDED
#define IMPRESSIONISTVIEW_H_INCLUDED

#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/fl_file_chooser.H>
#include <FL/Fl_Menu_Bar.H>
#include <FL/Fl_Value_Slider.H>
#include <FL/Fl_Choice.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Box.H>

#include "OriginalView.h"
#include "PaintView.h"
#include "Point.h"

class ImpressionistView 
{
public:
	ImpressionistView(ImpressionistModel* pModel);
	virtual ~ImpressionistView();

	void ResizeMainWnd(int iWidth, int iHeight);

	void Show();
	void UpdateWidgets();

protected:
	PaintView* m_pwndPaintView;
	OriginalView* m_pwndOrigView;

	// Main window
	Fl_Window* m_pwndMainWnd;
	// Main menu
	Fl_Menu_Bar* m_pmbMenuBar;
				
	// Paint dialog and widgets	in it	
	Fl_Window* m_pwndPaintDlg;
	Fl_Box* m_pbxManualPaintBox;
	Fl_Choice* m_pchoBrushTypeChoice;
	Fl_Slider* m_pslBrushSizeSlider;
	Fl_Button* m_btClear;

	ImpressionistModel* m_pmModel;

	// static class members
	static Fl_Menu_Item ms_mivMainMenu[];
	static Fl_Menu_Item ms_mivBrushTypeMenu[];

	static ImpressionistView* WhoAmI(Fl_Menu_* o);

	// menu callback functions

	static void LoadImage_cb(Fl_Menu_* o, void* v);
	static void SaveImage_cb(Fl_Menu_* o, void* v);
	static void PaintToolbox_cb(Fl_Menu_* o, void* v);
	static void SingleBuffer_cb(Fl_Menu_* o, void* v);
	static void DoubleBuffer_cb(Fl_Menu_* o, void* v);
	static void Exit_cb(Fl_Menu_* o, void* v);
	static void About_cb(Fl_Menu_* o, void* v);
	static void Exit2_cb(Fl_Widget* o, void* v);

	// paint dialog callback functions

	static void BrushChoice_cb(Fl_Widget* o, void* v);
	static void SizeSlider_cb(Fl_Widget* o, void* v);
	static void ClearButton_cb(Fl_Widget* o, void* v);
};

#endif // IMPRESSIONISTVIEW_H_INCLUDED
