#ifndef PAINTVIEW_H
#define PAINTVIEW_H

#include <FL/Fl.H>
#include <FL/Fl_Gl_Window.H>
#include <FL/gl.h>
#include <GL/glu.h>
#include <stdlib.h>

#include "Point.h"
#include "Brush.h"

class ImpressionistModel;
class ImpressionistView;
class OriginalView;

class PaintView : public Fl_Gl_Window
{
public:
	PaintView(int x, int y, int w, int h, const char *l);
	virtual ~PaintView();

	void set_model(ImpressionistModel *pmModel) { m_pmModel = pmModel; }

	void draw();
	int handle(int event);

	void resize_window(int width, int height);

	void save_current_content();
	void restore_content();

protected:
	ImpressionistModel* m_pmModel;

	Brush** m_ppbrBrushes;

	unsigned char* m_pbyCanvas;
	GLvoid* m_pPaintBitstart;
	int m_nDrawWidth, m_nDrawHeight;
	int m_nStartRow, m_nEndRow;
	int m_nStartCol, m_nEndCol;
	int m_nWindowWidth, m_nWindowHeight;
	bool m_bLButtonDown;
	bool m_bRButtonDown;

	int m_iEventToDo;
	bool m_bIsAnEvent;
	Point m_ptCoord;
	Point m_ptDirStart, m_ptDirEnd;
	bool m_bDrawToFrontBuffer;
};

#endif
